@echo off
echo If not already done, please plugin your button now for firmware update.
echo _
echo NOTE: Your pushbutton configuration will NOT be overwritten on this update.
echo _
echo If you are not sure, press CTRL-C and confirm with Yes to cancel this operation.
echo _
echo Press ENTER to continue
pause > nul


setlocal
for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "Arduino Leonardo"') do (
    call :resetCOM "%%~J"
)
rem newer windows can also use timeout. Ping works also on older windows.
rem ping 127.0.0.1 -n 2 > nul
goto :endkey


:resetCOM <WMIC_output_line>
rem sets _COM#=line
setlocal
set "str=%~1"
set "num=%str:*(COM=%"
set "num=%num:)=%"
set port=COM%num%

flashtool -p%port% -check pushbutton.hex
echo errorlevel: %errorlevel%
if errorlevel 1 goto :EOF

echo 1200 baud reset into bootloader for %port%
mode %port%: BAUD=1200 parity=N data=8 stop=1
timeout 3 > nul

REM first try
set success=0
for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "Arduino Leonardo bootloader"') do (
    call :setCOM "%%~J"
    set success=1
)
if %success%==1 goto :EOF

REM 2nd try
set success=0
for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "Arduino Micro bootloader"') do (
    call :setCOM "%%~J"
    set success=1
)
goto :EOF



:setCOM <WMIC_output_line>
rem sets _COM#=line
setlocal
set "str=%~1"
set "num=%str:*(COM=%"
set "num=%num:)=%"
set port=COM%num%
echo found bootloader at %port%
flashtool -p%port% -flash pushbutton.hex
goto :EOF

:endkey
echo Press any key to exit.
pause > nul
